# $Revision: 1.4 $, $Date: 2006/05/25 09:40:55 $
#
# Conditional build:
%bcond_without	tests		# do not perform "make test"
#
%include	/usr/lib/rpm/macros.perl
%define	pdir	UNIVERSAL
%define	pnam	can
Summary:	UNIVERSAL::can - Hack around people calling UNIVERSAL::can() as a function
Summary(pl):	UNIVERSAL::can - poprawianie ludzi wywoujcych UNIVERSAL::can() jako funkcj
Name:		perl-UNIVERSAL-can
Version:	1.12
Release:	1
# same as perl
License:	GPL v1+ or Artistic
Group:		Development/Languages/Perl
Source0:	http://www.cpan.org/modules/by-module/%{pdir}/%{pdir}-%{pnam}-%{version}.tar.gz
# Source0-md5:	4386c4f7479447fc5b51e8c3770cd2f4
URL:		http://search.cpan.org/dist/UNIVERSAL-can/
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	rpm-perlprov >= 4.1-13
%if %{with tests}
BuildRequires:	perl-Test-Simple >= 0.60
BuildRequires:	perl-Test-Warn >= 0.08
BuildRequires:	perl-Tree-DAG_Node
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The UNIVERSAL class provides a few default methods so that all objects
can use them. Object orientation allows programmers to override these
methods in subclasses to provide more specific and appropriate
behavior.

Some authors call methods in the UNIVERSAL class on potential
invocants as functions, bypassing any possible overriding. This is
wrong and you should not do it. Unfortunately, not everyone heeds this
warning and their bad code can break your good code.

Fortunately, this module replaces UNIVERSAL::can() with a method that
checks to see if the first argument is a valid invocant (whether an
object - a blessed referent - or the name of a class). If so, and if
the invocant's class has its own can() method, it calls that as a
method. Otherwise, everything works as you might expect.

If someone attempts to call UNIVERSAL::can() as a function, this
module will emit a lexical warning (see perllexwarn) to that effect.
You can disable it with no warnings; or no warnings 'UNIVERSAL::isa';,
but don't do that; fix the code instead.

%description -l pl
Klasa UNIVERSAL udostpnia kilka domylnych metod, ktre mog by
uywane przez wszystkie obiekty. Zorientowanie obiektowe pozwala
programistom przykry te metody w podklasach, aby zapewni bardziej
konkretne i odpowiednie zachowanie.

Niektrzy autorzy wywouj metody w klasie UNIVERSAL na potencjalnych
wywoujcych jako funkcje, pomijajc jakiekolwiek przykrywanie. Jest
to niedobre i nie naley tego robi. Niestety nie kady zwraca uwag
na to ostrzeenie i jego zy kod moe zepsu inny dobry kod.

Na szczcie ten modu zastpuje UNIVERSAL::can() metod sprawdzajc
czy pierwszy argument jest poprawnym wywoujcym (obiektem -
pobogosawion referencj - albo nazw klasy). Jeli tak, a klasa
wywoujcego ma wasn metod can(), wywouje j jako metod. W
przeciwnym wypadku wszystko dziaa tak, jak mona by si tego
spodziewa.

Jeli kto prbuje wywoa UNIVERSAL::can() jako funkcj, ten modu
wygeneruje ostrzeenie sowne (perllexwarn). Mona wyczy je - ale
nie naley tego robi, zamiast tego lepiej poprawi kod.

%prep
%setup -q -n %{pdir}-%{pnam}-%{version}

%build
%{__perl} Build.PL \
	destdir=$RPM_BUILD_ROOT \
	installdirs=vendor
./Build

%{?with_tests:./Build test}

%install
rm -rf $RPM_BUILD_ROOT

./Build install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes README
%{perl_vendorlib}/UNIVERSAL/*.pm
%{_mandir}/man3/*

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: perl-UNIVERSAL-can.spec,v $
Revision 1.4  2006/05/25 09:40:55  blaass
- up to 1.12

Revision 1.3  2006/02/20 21:35:05  glen
- 1.11

Revision 1.2  2005/11/15 22:55:07  qboosh
- pl, generic URL

Revision 1.1  2005/11/07 14:19:38  migo
- initial revision
